=== modified file 'NEWS'
--- NEWS	2008-02-07 08:47:27 +0000
+++ NEWS	2008-02-16 10:03:17 +0000
@@ -7,6 +7,42 @@
 IN DEVELOPMENT
 --------------
 
+  NOTES WHEN UPGRADING:
+  
+  CHANGES:
+
+    * BZR_LOG environment variable controls location of .bzr.log trace file. 
+      User can suppress writing messages to .bzr.log by using '/dev/null'
+      filename (on Linux) or 'NUL' (on Windows). If BZR_LOG variable 
+      is not defined but BZR_HOME is defined then default location
+      for .bzr.log trace file is ``$BZR_HOME/.bzr.log``.
+      (Alexander Belchenko)
+
+  FEATURES:
+
+  IMPROVEMENTS:
+
+  BUGFIXES:
+
+  API BREAKS:
+
+  TESTING:
+
+  INTERNALS:
+
+
+bzr 1.2rc1 (not released yet)
+-----------------------------
+
+  NOTES WHEN UPGRADING:
+  
+    * Fetching via the smart protocol may need to reconnect once during a fetch
+      if the remote server is running Bazaar 1.1 or earlier, because the client
+      attempts to use more efficient requests that confuse older servers.  You
+      may be required to re-enter a password or passphrase when this happens.
+      This won't happen if the server is upgraded to Bazaar 1.2.
+      (Andrew Bennetts)
+
   CHANGES:
 
     * Fetching via bzr+ssh will no longer fill ghosts by default (this is
@@ -16,10 +52,6 @@
       friendly. Full path of plugins locations will be shown only with
       ``--verbose`` command-line option. (Alexander Belchenko)
 
-    * If BZR_HOME environment variable is defined then default location
-      for .bzr.log trace file is ``$BZR_HOME/.bzr.log``.
-      (Alexander Belchenko)
-
     * ``merge`` now prefers to use the submit branch, but will fall back to
       parent branch.  For many users, this has no effect.  But some users who
       pull and merge on the same branch will notice a change.  This change
@@ -30,21 +62,34 @@
 
   FEATURES:
 
-    * BZR_LOG environment variable controls location of .bzr.log trace file. 
-      User can suppress writing messages to .bzr.log by using '/dev/null'
-      filename (on Linux) or 'NUL' (on Windows). (Alexander Belchenko)
-
     * ``merge --preview`` produces a diff of the changes merge would make,
       but does not actually perform the merge.  (Aaron Bentley)
 
+    * New smart method ``Repository.get_parent_map`` for getting revision
+      parent data. This returns additional parent information topologically
+      adjacent to the requested data to reduce round trip latency impacts.
+      (Robert Collins)
+
     * New smart method, ``Repository.stream_revisions_chunked``, for fetching
       revision data that streams revision data via a chunked encoding.  This
       avoids buffering large amounts of revision data on the server and on the
       client, and sends less data to the server to request the revisions.
       (Andrew Bennetts, Robert Collins, #178353)
 
+    * The launchpad plugin now handles lp urls of the form
+      ``lp://staging/``, ``lp://demo/``, ``lp://dev/`` to use the appropriate
+      launchpad instance to do the resolution of the branch identities.
+      This is primarily of use to Launchpad developers, but can also
+      be used by other users who want to try out Launchpad as
+      a branch location without messing up their public Launchpad
+      account.  Branches that are pushed to the staging environment
+      have an expected lifetime of one day. (Tim Penhey)
+
   IMPROVEMENTS:
 
+    * Creating a new branch no longer tries to read the entire revision-history
+      unnecessarily over smart server operations. (Robert Collins)
+
     * Fetching between different repository formats with compatible models now
       takes advantage of the smart method to stream revisions.  (Andrew Bennetts)
 
@@ -66,11 +111,22 @@
 
     * Cleanly handle connection errors in smart protocol version two, the same
       way as they are handled by version one.  (Andrew Bennetts)
+
+    * Clearer error when ``version-info --custom`` is used without
+      ``--template`` (Lukáš Lalinský)
       
     * List possible values for BZR_SSH environment variable in env-variables
       help topic. (Alexander Belchenko, #181842)
 
-    * pull --quiet is now more quiet, in particular a message is no longer
+    * New methods ``push_log_file`` and ``pop_log_file`` to intercept messages:
+      popping the log redirection now precisely restores the previous state,
+      which makes it easier to use bzr log output from other programs.
+      TestCaseInTempDir no longer depends on a log redirection being established
+      by the test framework, which lets bzr tests cleanly run from a normal
+      unittest runner.
+      (#124153, #124849, Martin Pool, Jonathan Lange)
+ 
+    * ``pull --quiet`` is now more quiet, in particular a message is no longer
       printed when the remembered pull location is used. (James Westby,
       #185907)
 
@@ -114,6 +170,10 @@
       ``SearchResult`` can be used to recreate the search later, which will
       be useful in reducing network traffic. (Robert Collins)
 
+    * Use convenience function to check whether two repository handles 
+      are referring to the same repository in ``Repository.get_graph``. 
+      (Jelmer Vernooij, #187162)
+
     * Fetching now passes the find_ghosts flag through to the 
       ``InterRepository.missing_revision_ids`` call consistently for all
       repository types. This will enable faster missing revision discovery with
@@ -145,6 +205,9 @@
       ``Repository.get_data_stream_for_search`` which allows less network
       traffic when requesting data streams over a smart server. (Robert Collins)
 
+    * ``RemoteBzrDir._get_tree_branch`` no longer triggers ``_ensure_real``,
+      removing one round trip on many network operations. (Robert Collins)
+
     * Repository has a new method ``has_revisions`` which signals the presence
       of many revisions by returning a set of the revisions listed which are
       present. This can be done by index queries without reading data for parent

=== modified file 'bzr'
--- bzr	2008-01-28 22:48:19 +0000
+++ bzr	2008-02-16 10:03:17 +0000
@@ -1,6 +1,6 @@
 #! /usr/bin/env python
 
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -22,7 +22,7 @@
 import sys
 
 # update this on each release
-_script_version = (1, 2, 0)
+_script_version = (1, 3, 0)
 
 if __doc__ is None:
     print "bzr does not support python -OO."
@@ -98,7 +98,7 @@
 
 
 if __name__ == '__main__':
-    bzrlib.trace.enable_default_logging(os.environ.get('BZR_LOG'))
+    bzrlib.trace.enable_default_logging()
     exit_val = bzrlib.commands.main(sys.argv)
 
     if profiling:

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2008-01-22 05:04:50 +0000
+++ bzrlib/__init__.py	2008-02-13 03:25:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -41,7 +41,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (1, 2, 0, 'dev', 0)
+version_info = (1, 3, 0, 'dev', 0)
 
 # API compatibility version: bzrlib is currently API compatible with 0.18.
 api_minimum_version = (0, 18, 0)

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2008-01-28 21:46:16 +0000
+++ bzrlib/branch.py	2008-02-06 04:06:42 +0000
@@ -436,12 +436,8 @@
         raise errors.UpgradeRequired(self.base)
 
     def last_revision(self):
-        """Return last revision id, or None"""
-        ph = self.revision_history()
-        if ph:
-            return ph[-1]
-        else:
-            return _mod_revision.NULL_REVISION
+        """Return last revision id, or NULL_REVISION."""
+        return self.last_revision_info()[1]
 
     def last_revision_info(self):
         """Return information about the last revision.
@@ -1824,120 +1820,6 @@
         return None
 
 
-class BzrBranchExperimental(BzrBranch5):
-    """Bzr experimental branch format
-
-    This format has:
-     - a revision-history file.
-     - a format string
-     - a lock dir guarding the branch itself
-     - all of this stored in a branch/ subdirectory
-     - works with shared repositories.
-     - a tag dictionary in the branch
-
-    This format is new in bzr 0.15, but shouldn't be used for real data, 
-    only for testing.
-
-    This class acts as it's own BranchFormat.
-    """
-
-    _matchingbzrdir = bzrdir.BzrDirMetaFormat1()
-
-    @classmethod
-    def get_format_string(cls):
-        """See BranchFormat.get_format_string()."""
-        return "Bazaar-NG branch format experimental\n"
-
-    @classmethod
-    def get_format_description(cls):
-        """See BranchFormat.get_format_description()."""
-        return "Experimental branch format"
-
-    @classmethod
-    def get_reference(cls, a_bzrdir):
-        """Get the target reference of the branch in a_bzrdir.
-
-        format probing must have been completed before calling
-        this method - it is assumed that the format of the branch
-        in a_bzrdir is correct.
-
-        :param a_bzrdir: The bzrdir to get the branch data from.
-        :return: None if the branch is not a reference branch.
-        """
-        return None
-
-    @classmethod
-    def set_reference(self, a_bzrdir, to_branch):
-        """Set the target reference of the branch in a_bzrdir.
-
-        format probing must have been completed before calling
-        this method - it is assumed that the format of the branch
-        in a_bzrdir is correct.
-
-        :param a_bzrdir: The bzrdir to set the branch reference for.
-        :param to_branch: branch that the checkout is to reference
-        """
-        raise NotImplementedError(self.set_reference)
-
-    @classmethod
-    def _initialize_control_files(cls, a_bzrdir, utf8_files, lock_filename,
-            lock_class):
-        branch_transport = a_bzrdir.get_branch_transport(cls)
-        control_files = lockable_files.LockableFiles(branch_transport,
-            lock_filename, lock_class)
-        control_files.create_lock()
-        control_files.lock_write()
-        try:
-            for filename, content in utf8_files:
-                control_files.put_utf8(filename, content)
-        finally:
-            control_files.unlock()
-        
-    @classmethod
-    def initialize(cls, a_bzrdir):
-        """Create a branch of this format in a_bzrdir."""
-        utf8_files = [('format', cls.get_format_string()),
-                      ('revision-history', ''),
-                      ('branch-name', ''),
-                      ('tags', ''),
-                      ]
-        cls._initialize_control_files(a_bzrdir, utf8_files,
-            'lock', lockdir.LockDir)
-        return cls.open(a_bzrdir, _found=True)
-
-    @classmethod
-    def open(cls, a_bzrdir, _found=False):
-        """Return the branch object for a_bzrdir
-
-        _found is a private parameter, do not use it. It is used to indicate
-               if format probing has already be done.
-        """
-        if not _found:
-            format = BranchFormat.find_format(a_bzrdir)
-            assert format.__class__ == cls
-        transport = a_bzrdir.get_branch_transport(None)
-        control_files = lockable_files.LockableFiles(transport, 'lock',
-                                                     lockdir.LockDir)
-        return cls(_format=cls,
-            _control_files=control_files,
-            a_bzrdir=a_bzrdir,
-            _repository=a_bzrdir.find_repository())
-
-    @classmethod
-    def is_supported(cls):
-        return True
-
-    def _make_tags(self):
-        return BasicTags(self)
-
-    @classmethod
-    def supports_tags(cls):
-        return True
-
-
-BranchFormat.register_format(BzrBranchExperimental)
-
-
 class BzrBranch6(BzrBranch5):
 
     @needs_read_lock
@@ -1948,11 +1830,6 @@
         revno = int(revno)
         return revno, revision_id
 
-    def last_revision(self):
-        """Return last revision id, or None"""
-        revision_id = self.last_revision_info()[1]
-        return revision_id
-
     def _write_last_revision_info(self, revno, revision_id):
         """Simply write out the revision id, with no checks.
 

=== modified file 'bzrlib/bundle/commands.py'
--- bzrlib/bundle/commands.py	2007-10-16 16:02:01 +0000
+++ bzrlib/bundle/commands.py	2008-02-13 01:31:33 +0000
@@ -59,8 +59,8 @@
             bundle_info = read_bundle(bundle_file)
         else:
             if verbose:
-                raise errors.BzrCommandError('Verbose requires a merge'
-                                             ' directive')
+                raise errors.BzrCommandError('--verbose requires a merge'
+                    ' directive')
         reader_method = getattr(bundle_info, 'get_bundle_reader', None)
         if reader_method is None:
             raise errors.BzrCommandError('Bundle format not supported')

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2008-01-17 13:45:16 +0000
+++ bzrlib/bzrdir.py	2008-02-04 03:50:39 +0000
@@ -748,7 +748,7 @@
     def _get_tree_branch(self):
         """Return the branch and tree, if any, for this bzrdir.
 
-        Return None for tree if not present.
+        Return None for tree if not present or inaccessible.
         Raise NotBranchError if no branch is present.
         :return: (tree, branch)
         """

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2007-12-19 08:12:34 +0000
+++ bzrlib/dirstate.py	2008-02-12 02:14:04 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -321,6 +321,9 @@
         # modified states.
         self._header_state = DirState.NOT_IN_MEMORY
         self._dirblock_state = DirState.NOT_IN_MEMORY
+        # If true, an error has been detected while updating the dirstate, and 
+        # for safety we're not going to commit to disk.
+        self._changes_aborted = False
         self._dirblocks = []
         self._ghosts = []
         self._parents = []
@@ -1292,13 +1295,15 @@
             assert old_path is None
             # the entry for this file_id must be in tree 0.
             entry = self._get_entry(0, file_id, new_path)
-            if entry[0][2] != file_id:
-                raise errors.BzrError('dirstate: cannot apply delta, working'
-                    ' tree does not contain new entry %r %r' %
-                    (new_path, file_id))
+            if entry[0] is None or entry[0][2] != file_id:
+                self._changes_aborted = True
+                raise errors.InconsistentDelta(new_path, file_id,
+                    'working tree does not contain new entry')
             if real_add and entry[1][1][0] not in absent:
-                raise errors.BzrError('dirstate: inconsistent delta, with '
-                    'tree 0. %r %r' % (new_path, file_id))
+                self._changes_aborted = True
+                raise errors.InconsistentDelta(new_path, file_id,
+                    'The entry was considered to be a genuinely new record,'
+                    ' but there was already an old record for it.')
             # We don't need to update the target of an 'r' because the handling
             # of renames turns all 'r' situations into a delete at the original
             # location.
@@ -1315,14 +1320,15 @@
             assert old_path == new_path
             # the entry for this file_id must be in tree 0.
             entry = self._get_entry(0, file_id, new_path)
-            if entry[0][2] != file_id:
-                raise errors.BzrError('dirstate: cannot apply delta, working'
-                    ' tree does not contain new entry %r %r' %
-                    (new_path, file_id))
+            if entry[0] is None or entry[0][2] != file_id:
+                self._changes_aborted = True
+                raise errors.InconsistentDelta(new_path, file_id,
+                    'working tree does not contain new entry')
             if (entry[1][0][0] in absent or
                 entry[1][1][0] in absent):
-                raise errors.BzrError('dirstate: inconsistent delta, with '
-                    'tree 0. %r %r' % (new_path, file_id))
+                self._changes_aborted = True
+                raise errors.InconsistentDelta(new_path, file_id,
+                    'changed considered absent')
             entry[1][1] = new_details
 
     def _update_basis_apply_deletes(self, deletes):
@@ -1348,22 +1354,31 @@
             block_index, entry_index, dir_present, file_present = \
                 self._get_block_entry_index(dirname, basename, 1)
             if not file_present:
-                raise errors.BzrError('dirstate: cannot apply delta, basis'
-                    ' tree does not contain new entry %r %r' %
-                    (old_path, file_id))
+                self._changes_aborted = True
+                raise errors.InconsistentDelta(old_path, file_id,
+                    'basis tree does not contain removed entry')
             entry = self._dirblocks[block_index][1][entry_index]
             if entry[0][2] != file_id:
-                raise errors.BzrError('mismatched file_id in tree 1 %r %r' %
-                    (old_path, file_id))
+                self._changes_aborted = True
+                raise errors.InconsistentDelta(old_path, file_id,
+                    'mismatched file_id in tree 1')
             if real_delete:
                 if entry[1][0][0] != 'a':
-                    raise errors.BzrError('dirstate: inconsistent delta, with '
-                        'tree 0. %r %r' % (old_path, file_id))
+                    self._changes_aborted = True
+                    raise errors.InconsistentDelta(old_path, file_id,
+                            'This was marked as a real delete, but the WT state'
+                            ' claims that it still exists and is versioned.')
                 del self._dirblocks[block_index][1][entry_index]
             else:
                 if entry[1][0][0] == 'a':
-                    raise errors.BzrError('dirstate: inconsistent delta, with '
-                        'tree 0. %r %r' % (old_path, file_id))
+                    self._changes_aborted = True
+                    raise errors.InconsistentDelta(old_path, file_id,
+                        'The entry was considered a rename, but the source path'
+                        ' is marked as absent.')
+                    # For whatever reason, we were asked to rename an entry
+                    # that was originally marked as deleted. This could be
+                    # because we are renaming the parent directory, and the WT
+                    # current state has the file marked as deleted.
                 elif entry[1][0][0] == 'r':
                     # implement the rename
                     del self._dirblocks[block_index][1][entry_index]
@@ -1666,6 +1681,7 @@
             assert entry[0][2] and entry[1][tree_index][0] not in ('a', 'r'), 'unversioned entry?!?!'
             if fileid_utf8:
                 if entry[0][2] != fileid_utf8:
+                    self._changes_aborted = True
                     raise errors.BzrError('integrity error ? : mismatching'
                                           ' tree_index, file_id and path')
             return entry
@@ -1954,6 +1970,12 @@
         start over, to allow for fine grained read lock duration, so 'status'
         wont block 'commit' - for example.
         """
+        if self._changes_aborted:
+            # Should this be a warning? For now, I'm expecting that places that
+            # mark it inconsistent will warn, making a warning here redundant.
+            trace.mutter('Not saving DirState because '
+                    '_changes_aborted is set.')
+            return
         if (self._header_state == DirState.IN_MEMORY_MODIFIED or
             self._dirblock_state == DirState.IN_MEMORY_MODIFIED):
 
@@ -2598,6 +2620,7 @@
         """Forget all state information about the dirstate."""
         self._header_state = DirState.NOT_IN_MEMORY
         self._dirblock_state = DirState.NOT_IN_MEMORY
+        self._changes_aborted = False
         self._parents = []
         self._ghosts = []
         self._dirblocks = []

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2008-01-25 10:46:10 +0000
+++ bzrlib/errors.py	2008-02-12 02:13:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -1981,6 +1981,17 @@
     _fmt = "Format error in conflict listings"
 
 
+class CorruptDirstate(BzrError):
+
+    _fmt = ("Inconsistency in dirstate file %(dirstate_path)s.\n"
+            "Error: %(description)s")
+
+    def __init__(self, dirstate_path, description):
+        BzrError.__init__(self)
+        self.dirstate_path = dirstate_path
+        self.description = description
+
+
 class CorruptRepository(BzrError):
 
     _fmt = ("An error has been detected in the repository %(repo_path)s.\n"
@@ -1991,6 +2002,19 @@
         self.repo_path = repo.bzrdir.root_transport.base
 
 
+class InconsistentDelta(BzrError):
+    """Used when we get a delta that is not valid."""
+
+    _fmt = ("An inconsistent delta was supplied involving %(path)r,"
+            " %(file_id)r\nreason: %(reason)s")
+
+    def __init__(self, path, file_id, reason):
+        BzrError.__init__(self)
+        self.path = path
+        self.file_id = file_id
+        self.reason = reason
+
+
 class UpgradeRequired(BzrError):
 
     _fmt = "To use this feature you must upgrade your branch at %(path)s."
@@ -2520,6 +2544,11 @@
         self.name = name
 
 
+class NoTemplate(BzrError):
+
+    _fmt = 'No template specified.'
+
+
 class UnableCreateSymlink(BzrError):
 
     _fmt = 'Unable to create symlink %(path_str)son this platform'

=== modified file 'bzrlib/graph.py'
--- bzrlib/graph.py	2008-01-29 06:56:51 +0000
+++ bzrlib/graph.py	2008-02-03 22:55:08 +0000
@@ -514,7 +514,7 @@
             # exclude keys for them. However, while we could have a second
             # look-ahead result buffer and shuffle things around, this method
             # is typically only called once per search - when memoising the
-            # results of the search.
+            # results of the search. 
             found, ghosts, next, parents = self._do_query(self._next_query)
             # pretend we didn't query: perhaps we should tweak _do_query to be
             # entirely stateless?

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2008-01-15 16:26:43 +0000
+++ bzrlib/knit.py	2008-02-08 03:18:35 +0000
@@ -874,7 +874,7 @@
 
         This data is intended to be used for retrieving the knit records.
 
-        A dict of version_id to (method, data_pos, data_size, next) is
+        A dict of version_id to (method, index_memo, next) is
         returned.
         method is the way referenced data should be applied.
         data_pos is the position of the data in the knit.
@@ -882,18 +882,15 @@
         next is the build-parent of the version, or None for fulltexts.
         """
         component_data = {}
-        for version_id in version_ids:
-            cursor = version_id
-
-            while cursor is not None and cursor not in component_data:
-                method = self._index.get_method(cursor)
-                if method == 'fulltext':
-                    next = None
-                else:
-                    next = self.get_parents_with_ghosts(cursor)[0]
-                index_memo = self._index.get_position(cursor)
-                component_data[cursor] = (method, index_memo, next)
-                cursor = next
+        pending_components = version_ids
+        while pending_components:
+            build_details = self._index.get_build_details(pending_components)
+            pending_components = set()
+            for version_id, details in build_details.items():
+                method, index_memo, compression_parent = details
+                if compression_parent is not None:
+                    pending_components.add(compression_parent)
+                component_data[version_id] = details
         return component_data
        
     def _get_content(self, version_id, parent_texts={}):
@@ -1426,6 +1423,23 @@
                 graph[version] = parents
         return topo_sort(graph.items())
 
+    def get_build_details(self, version_ids):
+        """Get the method, index_memo and compression parent for version_ids.
+
+        :param version_ids: An iterable of version_ids.
+        :return: A dict of version_id:(method, index_memo, compression_parent).
+        """
+        result = {}
+        for version_id in version_ids:
+            method = self.get_method(version_id)
+            if method == 'fulltext':
+                compression_parent = None
+            else:
+                compression_parent = self.get_parents_with_ghosts(version_id)[0]
+            index_memo = self.get_position(version_id)
+            result[version_id] = (method, index_memo, compression_parent)
+        return result
+
     def iter_parents(self, version_ids):
         """Iterate through the parents for many version ids.
 
@@ -1689,6 +1703,50 @@
         result_keys = topo_sort(graph.items())
         return [key[0] for key in result_keys]
 
+    def get_build_details(self, version_ids):
+        """Get the method, index_memo and compression parent for version_ids.
+
+        :param version_ids: An iterable of version_ids.
+        :return: A dict of version_id:(method, index_memo, compression_parent).
+        """
+        result = {}
+        entries = self._get_entries(self._version_ids_to_keys(version_ids), True)
+        for entry in entries:
+            version_id = self._keys_to_version_ids((entry[1],))[0]
+            if not self._deltas:
+                compression_parent = None
+            else:
+                compression_parent_key = self._compression_parent(entry)
+                if compression_parent_key:
+                    compression_parent = self._keys_to_version_ids(
+                    (compression_parent_key,))[0]
+                else:
+                    compression_parent = None
+            if compression_parent:
+                method = 'line-delta'
+            else:
+                method = 'fulltext'
+            result[version_id] = (method, self._node_to_position(entry),
+                compression_parent)
+        return result
+
+    def _compression_parent(self, an_entry):
+        # return the key that an_entry is compressed against, or None
+        # Grab the second parent list (as deltas implies parents currently)
+        compression_parents = an_entry[3][1]
+        if not compression_parents:
+            return None
+        assert len(compression_parents) == 1
+        return compression_parents[0]
+
+    def _get_method(self, node):
+        if not self._deltas:
+            return 'fulltext'
+        if self._compression_parent(node):
+            return 'line-delta'
+        else:
+            return 'fulltext'
+
     def get_graph(self):
         """Return a list of the node:parents lists from this knit index."""
         if not self._parents:
@@ -1750,21 +1808,16 @@
             logic to get the record.
         """
         node = self._get_node(version_id)
+        return self._node_to_position(node)
+
+    def _node_to_position(self, node):
+        """Convert an index value to position details."""
         bits = node[2][1:].split(' ')
         return node[0], int(bits[0]), int(bits[1])
 
     def get_method(self, version_id):
         """Return compression method of specified version."""
-        if not self._deltas:
-            return 'fulltext'
-        return self._parent_compression(self._get_node(version_id)[3][1])
-
-    def _parent_compression(self, reference_list):
-        # use the second reference list to decide if this is delta'd or not.
-        if len(reference_list):
-            return 'line-delta'
-        else:
-            return 'fulltext'
+        return self._get_method(self._get_node(version_id))
 
     def _get_node(self, version_id):
         try:
@@ -1778,10 +1831,7 @@
         e.g. ['foo', 'bar']
         """
         node = self._get_node(version_id)
-        if not self._deltas:
-            options = ['fulltext']
-        else:
-            options = [self._parent_compression(node[3][1])]
+        options = [self._get_method(node)]
         if node[2][0] == 'N':
             options.append('no-eol')
         return options
@@ -2159,6 +2209,23 @@
             ancestry.add(version)
         return list(ancestry)
 
+    def get_build_details(self, version_ids):
+        """Get the method, index_memo and compression parent for version_ids.
+
+        :param version_ids: An iterable of version_ids.
+        :return: A dict of version_id:(method, index_memo, compression_parent).
+        """
+        result = {}
+        for version_id in version_ids:
+            method = self.get_method(version_id)
+            if method == 'fulltext':
+                compression_parent = None
+            else:
+                compression_parent = self.get_parents_with_ghosts(version_id)[0]
+            index_memo = self.get_position(version_id)
+            result[version_id] = (method, index_memo, compression_parent)
+        return result
+
     def get_method(self, version_id):
         """Return compression method of specified version."""
         try:

=== modified file 'bzrlib/plugins/launchpad/__init__.py'
--- bzrlib/plugins/launchpad/__init__.py	2008-01-25 11:52:56 +0000
+++ bzrlib/plugins/launchpad/__init__.py	2008-02-05 02:28:04 +0000
@@ -176,20 +176,21 @@
     'bzrlib.plugins.launchpad.lp_indirect',
     'LaunchpadTransport')
 
-register_lazy_transport(
-    'lp://',
-    'bzrlib.plugins.launchpad.lp_indirect',
-    'LaunchpadTransport')
 
 def test_suite():
     """Called by bzrlib to fetch tests for this plugin"""
     from unittest import TestSuite, TestLoader
     from bzrlib.plugins.launchpad import (
-        test_register, test_lp_indirect, test_account)
+        test_register, test_lp_indirect, test_lp_registration, test_account)
 
     loader = TestLoader()
     suite = TestSuite()
-    for m in [test_register, test_lp_indirect, test_account]:
+    for m in [
+        test_account,
+        test_register,
+        test_lp_indirect,
+        test_lp_registration,
+        ]:
         suite.addTests(loader.loadTestsFromModule(m))
     return suite
 

=== modified file 'bzrlib/plugins/launchpad/lp_indirect.py'
--- bzrlib/plugins/launchpad/lp_indirect.py	2007-12-05 01:36:54 +0000
+++ bzrlib/plugins/launchpad/lp_indirect.py	2008-01-22 08:40:50 +0000
@@ -58,8 +58,10 @@
     def __init__(self, base):
         super(LaunchpadTransport, self).__init__(base)
         # We only support URLs without a netloc
-        netloc = urlsplit(base)[1]
-        if netloc != '':
+        self.lp_instance = urlsplit(base)[1]
+        if self.lp_instance == '':
+            self.lp_instance = None
+        elif self.lp_instance not in LaunchpadService.LAUNCHPAD_INSTANCE:
             raise errors.InvalidURL(path=base)
 
     def _requires_launchpad_login(self, scheme, netloc, path, query,
@@ -80,7 +82,7 @@
         path = urlsplit(abspath)[2].lstrip('/')
         # Perform an XMLRPC request to resolve the path
         resolve = _request_factory(path)
-        service = LaunchpadService()
+        service = LaunchpadService(lp_instance=self.lp_instance)
         try:
             result = resolve.submit(service)
         except xmlrpclib.Fault, fault:

=== modified file 'bzrlib/plugins/launchpad/lp_registration.py'
--- bzrlib/plugins/launchpad/lp_registration.py	2008-01-25 11:06:32 +0000
+++ bzrlib/plugins/launchpad/lp_registration.py	2008-02-05 02:28:04 +0000
@@ -32,27 +32,43 @@
 export BZR_LP_XMLRPC_URL=http://xmlrpc.staging.launchpad.net/bazaar/
 '''
 
+class InvalidLaunchpadInstance(errors.BzrError):
+
+    _fmt = "%(lp_instance)s is not a valid Launchpad instance."
+
+    def __init__(self, lp_instance):
+        errors.BzrError.__init__(self, lp_instance=lp_instance)
+
+
 class LaunchpadService(object):
     """A service to talk to Launchpad via XMLRPC.
-    
+
     See http://bazaar-vcs.org/Specs/LaunchpadRpc for the methods we can call.
     """
 
-    # NB: this should always end in a slash to avoid xmlrpclib appending
+    # NB: these should always end in a slash to avoid xmlrpclib appending
     # '/RPC2'
-    # We use edge because:
+    # We use edge as the default because:
     # Beta users get redirected to it
     # All users can use it
     # There is a bug in the launchpad side where redirection causes an OOPS.
-    DEFAULT_SERVICE_URL = 'https://xmlrpc.edge.launchpad.net/bazaar/'
+    LAUNCHPAD_INSTANCE = {
+        'production': 'https://xmlrpc.launchpad.net/bazaar/',
+        'edge': 'https://xmlrpc.edge.launchpad.net/bazaar/',
+        'staging': 'https://xmlrpc.staging.launchpad.net/bazaar/',
+        'demo': 'https://xmlrpc.demo.launchpad.net/bazaar/',
+        'dev': 'http://xmlrpc.launchpad.dev/bazaar/',
+        }
+    DEFAULT_SERVICE_URL = LAUNCHPAD_INSTANCE['edge']
 
     transport = None
     registrant_email = None
     registrant_password = None
 
 
-    def __init__(self, transport=None):
+    def __init__(self, transport=None, lp_instance=None):
         """Construct a new service talking to the launchpad rpc server"""
+        self._lp_instance = lp_instance
         if transport is None:
             uri_type = urllib.splittype(self.service_url)[0]
             if uri_type == 'https':
@@ -73,6 +89,11 @@
         key = 'BZR_LP_XMLRPC_URL'
         if key in os.environ:
             return os.environ[key]
+        elif self._lp_instance is not None:
+            try:
+                return self.LAUNCHPAD_INSTANCE[self._lp_instance]
+            except KeyError:
+                raise InvalidLaunchpadInstance(self._lp_instance)
         else:
             return self.DEFAULT_SERVICE_URL
 

=== modified file 'bzrlib/plugins/launchpad/test_lp_indirect.py'
--- bzrlib/plugins/launchpad/test_lp_indirect.py	2007-11-27 01:01:01 +0000
+++ bzrlib/plugins/launchpad/test_lp_indirect.py	2008-01-22 23:11:21 +0000
@@ -40,6 +40,7 @@
         return self
 
     def submit(self, service):
+        self._service_url = service.service_url
         return self._result
 
 
@@ -54,6 +55,22 @@
         transport = LaunchpadTransport('lp:///')
         self.assertEquals('http://bazaar.launchpad.net/~apt/apt/devel',
                           transport._resolve('lp:apt', factory))
+        # Make sure that resolve went to the production server.
+        self.assertEquals('https://xmlrpc.launchpad.net/bazaar/',
+                          factory._service_url)
+
+    def test_staging(self):
+        """A launchpad url should map to a http url"""
+        factory = FakeResolveFactory(
+            self, 'apt', dict(urls=[
+                    'http://bazaar.staging.launchpad.net/~apt/apt/devel']))
+        url = 'lp://staging/apt'
+        transport = LaunchpadTransport(url)
+        self.assertEquals('http://bazaar.staging.launchpad.net/~apt/apt/devel',
+                          transport._resolve(url, factory))
+        # Make sure that resolve went to the staging server.
+        self.assertEquals('https://xmlrpc.staging.launchpad.net/bazaar/',
+                          factory._service_url)
 
     def test_indirect_through_url(self):
         """A launchpad url should map to a http url"""

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2007-12-30 18:20:15 +0000
+++ bzrlib/progress.py	2008-02-13 03:30:01 +0000
@@ -16,22 +16,18 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""Simple text-mode progress indicator.
-
-To display an indicator, create a ProgressBar object.  Call it,
-passing Progress objects indicating the current state.  When done,
-call clear().
-
-Progress is suppressed when output is not sent to a terminal, so as
-not to clutter log files.
+"""Progress indicators.
+
+The usual way to use this is via bzrlib.ui.ui_factory.nested_progress_bar which
+will maintain a ProgressBarStack for you.
+
+For direct use, the factory ProgressBar will return an auto-detected progress
+bar that should match your terminal type. You can manually create a
+ProgressBarStack too if you need multiple levels of cooperating progress bars.
+Note that bzrlib's internal functions use the ui module, so if you are using
+bzrlib it really is best to use bzrlib.ui.ui_factory.
 """
 
-# TODO: should be a global option e.g. --silent that disables progress
-# indicators, preferably without needing to adjust all code that
-# potentially calls them.
-
-# TODO: If not on a tty perhaps just print '......' for the benefit of IDEs, etc
-
 # TODO: Optionally show elapsed time instead/as well as ETA; nicer
 # when the rate is unpredictable
 
@@ -298,7 +294,6 @@
         self.child_fraction = 0
         self._have_output = False
     
-
     def throttle(self, old_msg):
         """Return True if the bar was updated too recently"""
         # time.time consistently takes 40/4000 ms = 0.01 ms.
@@ -320,7 +315,7 @@
         return False
         
     def tick(self):
-        self.update(self.last_msg, self.last_cnt, self.last_total, 
+        self.update(self.last_msg, self.last_cnt, self.last_total,
                     self.child_fraction)
 
     def child_update(self, message, current, total):
@@ -336,7 +331,7 @@
             self.last_msg = ''
         self.tick()
 
-    def update(self, msg, current_cnt=None, total_cnt=None, 
+    def update(self, msg, current_cnt=None, total_cnt=None,
                child_fraction=0):
         """Update and redraw progress bar."""
         if msg is None:
@@ -438,7 +433,7 @@
         self._have_output = True
         #self.to_file.flush()
             
-    def clear(self):        
+    def clear(self):
         if self._have_output:
             self.to_file.write('\r%s\r' % (' ' * (self.width - 1)))
         self._have_output = False
@@ -568,40 +563,3 @@
             self.cur_phase += 1
         assert self.cur_phase < self.total
         self.pb.update(self.message, self.cur_phase, self.total)
-
-
-def run_tests():
-    import doctest
-    result = doctest.testmod()
-    if result[1] > 0:
-        if result[0] == 0:
-            print "All tests passed"
-    else:
-        print "No tests to run"
-
-
-def demo():
-    sleep = time.sleep
-    
-    print 'dumb-terminal test:'
-    pb = DotsProgressBar()
-    for i in range(100):
-        pb.update('Leoparden', i, 99)
-        sleep(0.1)
-    sleep(1.5)
-    pb.clear()
-    sleep(1.5)
-    
-    print 'smart-terminal test:'
-    pb = ProgressBar(show_pct=True, show_bar=True, show_spinner=False)
-    for i in range(100):
-        pb.update('Elephanten', i, 99)
-        sleep(0.1)
-    sleep(2)
-    pb.clear()
-    sleep(1)
-
-    print 'done!'
-
-if __name__ == "__main__":
-    demo()

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2008-01-29 03:22:52 +0000
+++ bzrlib/remote.py	2008-02-07 03:47:24 +0000
@@ -17,6 +17,7 @@
 # TODO: At some point, handle upgrades by just passing the whole request
 # across to run on the server.
 
+import bz2
 from cStringIO import StringIO
 
 from bzrlib import (
@@ -41,7 +42,7 @@
     zero_ninetyone,
     )
 from bzrlib.revision import NULL_REVISION
-from bzrlib.trace import mutter, note
+from bzrlib.trace import mutter, note, warning
 
 # Note: RemoteBzrDirFormat is in bzrdir.py
 
@@ -130,6 +131,10 @@
         else:
             raise errors.UnexpectedSmartServerResponse(response)
 
+    def _get_tree_branch(self):
+        """See BzrDir._get_tree_branch()."""
+        return None, self.open_branch()
+
     def open_branch(self, _unsupported=False):
         assert _unsupported == False, 'unsupported flag support not implemented yet.'
         reference_url = self.get_branch_reference()
@@ -268,6 +273,8 @@
         self._leave_lock = False
         # A cache of looked up revision parent data; reset at unlock time.
         self._parents_map = None
+        if 'hpss' in debug.debug_flags:
+            self._requested_parents = None
         # For tests:
         # These depend on the actual remote format, so force them off for
         # maximum compatibility. XXX: In future these should depend on the
@@ -472,6 +479,8 @@
             self._lock_mode = 'r'
             self._lock_count = 1
             self._parents_map = {}
+            if 'hpss' in debug.debug_flags:
+                self._requested_parents = set()
             if self._real_repository is not None:
                 self._real_repository.lock_read()
         else:
@@ -510,6 +519,8 @@
             self._lock_mode = 'w'
             self._lock_count = 1
             self._parents_map = {}
+            if 'hpss' in debug.debug_flags:
+                self._requested_parents = set()
         elif self._lock_mode == 'r':
             raise errors.ReadOnlyError(self)
         else:
@@ -570,6 +581,8 @@
         if self._lock_count > 0:
             return
         self._parents_map = None
+        if 'hpss' in debug.debug_flags:
+            self._requested_parents = None
         old_mode = self._lock_mode
         self._lock_mode = None
         try:
@@ -764,15 +777,25 @@
         """See bzrlib.Graph.get_parent_map()."""
         # Hack to build up the caching logic.
         ancestry = self._parents_map
-        missing_revisions = set(key for key in keys if key not in ancestry)
+        if ancestry is None:
+            # Repository is not locked, so there's no cache.
+            missing_revisions = set(keys)
+            ancestry = {}
+        else:
+            missing_revisions = set(key for key in keys if key not in ancestry)
         if missing_revisions:
             parent_map = self._get_parent_map(missing_revisions)
             if 'hpss' in debug.debug_flags:
                 mutter('retransmitted revisions: %d of %d',
-                        len(set(self._parents_map).intersection(parent_map)),
+                        len(set(ancestry).intersection(parent_map)),
                         len(parent_map))
-            self._parents_map.update(parent_map)
-        return dict((k, ancestry[k]) for k in keys if k in ancestry)
+            ancestry.update(parent_map)
+        present_keys = [k for k in keys if k in ancestry]
+        if 'hpss' in debug.debug_flags:
+            self._requested_parents.update(present_keys)
+            mutter('Current RemoteRepository graph hit rate: %d%%',
+                100.0 * len(self._requested_parents) / len(ancestry))
+        return dict((k, ancestry[k]) for k in present_keys)
 
     def _response_is_unknown_method(self, response, verb):
         """Return True if response is an unknonwn method response to verb.
@@ -794,6 +817,13 @@
 
     def _get_parent_map(self, keys):
         """Helper for get_parent_map that performs the RPC."""
+        medium = self._client.get_smart_medium()
+        if not medium._remote_is_at_least_1_2:
+            # We already found out that the server can't understand
+            # Repository.get_parent_map requests, so just fetch the whole
+            # graph.
+            return self.get_revision_graph()
+
         keys = set(keys)
         if NULL_REVISION in keys:
             keys.discard(NULL_REVISION)
@@ -802,24 +832,55 @@
                 return found_parents
         else:
             found_parents = {}
+        # TODO(Needs analysis): We could assume that the keys being requested
+        # from get_parent_map are in a breadth first search, so typically they
+        # will all be depth N from some common parent, and we don't have to
+        # have the server iterate from the root parent, but rather from the
+        # keys we're searching; and just tell the server the keyspace we
+        # already have; but this may be more traffic again.
+
+        # Transform self._parents_map into a search request recipe.
+        # TODO: Manage this incrementally to avoid covering the same path
+        # repeatedly. (The server will have to on each request, but the less
+        # work done the better).
+        parents_map = self._parents_map
+        if parents_map is None:
+            # Repository is not locked, so there's no cache.
+            parents_map = {}
+        start_set = set(parents_map)
+        result_parents = set()
+        for parents in parents_map.itervalues():
+            result_parents.update(parents)
+        stop_keys = result_parents.difference(start_set)
+        included_keys = start_set.intersection(result_parents)
+        start_set.difference_update(included_keys)
+        recipe = (start_set, stop_keys, len(parents_map))
+        body = self._serialise_search_recipe(recipe)
         path = self.bzrdir._path_for_remote_call(self._client)
         for key in keys:
             assert type(key) is str
         verb = 'Repository.get_parent_map'
-        response = self._client.call_expecting_body(
-            verb, path, *keys)
+        args = (path,) + tuple(keys)
+        response = self._client.call_with_body_bytes_expecting_body(
+            verb, args, self._serialise_search_recipe(recipe))
         if self._response_is_unknown_method(response, verb):
-            # Server that does not support this method, get the whole graph.
-            response = self._client.call_expecting_body(
-                'Repository.get_revision_graph', path, '')
-            if response[0][0] not in ['ok', 'nosuchrevision']:
-                reponse[1].cancel_read_body()
-                raise errors.UnexpectedSmartServerResponse(response[0])
+            # Server does not support this method, so get the whole graph.
+            # Worse, we have to force a disconnection, because the server now
+            # doesn't realise it has a body on the wire to consume, so the
+            # only way to recover is to abandon the connection.
+            warning(
+                'Server is too old for fast get_parent_map, reconnecting.  '
+                '(Upgrade the server to Bazaar 1.2 to avoid this)')
+            medium.disconnect()
+            # To avoid having to disconnect repeatedly, we keep track of the
+            # fact the server doesn't understand remote methods added in 1.2.
+            medium._remote_is_at_least_1_2 = False
+            return self.get_revision_graph()
         elif response[0][0] not in ['ok']:
             reponse[1].cancel_read_body()
             raise errors.UnexpectedSmartServerResponse(response[0])
         if response[0][0] == 'ok':
-            coded = response[1].read_body_bytes()
+            coded = bz2.decompress(response[1].read_body_bytes())
             if coded == '':
                 # no revisions found
                 return {}
@@ -970,29 +1031,37 @@
         return self._real_repository.has_signature_for_revision_id(revision_id)
 
     def get_data_stream_for_search(self, search):
+        medium = self._client.get_smart_medium()
+        if not medium._remote_is_at_least_1_2:
+            self._ensure_real()
+            return self._real_repository.get_data_stream_for_search(search)
         REQUEST_NAME = 'Repository.stream_revisions_chunked'
         path = self.bzrdir._path_for_remote_call(self._client)
-        recipe = search.get_recipe()
-        start_keys = ' '.join(recipe[0])
-        stop_keys = ' '.join(recipe[1])
-        count = str(recipe[2])
-        body = '\n'.join((start_keys, stop_keys, count))
+        body = self._serialise_search_recipe(search.get_recipe())
         response, protocol = self._client.call_with_body_bytes_expecting_body(
             REQUEST_NAME, (path,), body)
 
+        if self._response_is_unknown_method((response, protocol), REQUEST_NAME):
+            # Server does not support this method, so fall back to VFS.
+            # Worse, we have to force a disconnection, because the server now
+            # doesn't realise it has a body on the wire to consume, so the
+            # only way to recover is to abandon the connection.
+            warning(
+                'Server is too old for streaming pull, reconnecting.  '
+                '(Upgrade the server to Bazaar 1.2 to avoid this)')
+            medium.disconnect()
+            # To avoid having to disconnect repeatedly, we keep track of the
+            # fact the server doesn't understand this remote method.
+            medium._remote_is_at_least_1_2 = False
+            self._ensure_real()
+            return self._real_repository.get_data_stream_for_search(search)
+
         if response == ('ok',):
             return self._deserialise_stream(protocol)
         if response == ('NoSuchRevision', ):
             # We cannot easily identify the revision that is missing in this
             # situation without doing much more network IO. For now, bail.
             raise NoSuchRevision(self, "unknown")
-        elif (response == ('error', "Generic bzr smart protocol error: "
-                "bad request '%s'" % REQUEST_NAME) or
-              response == ('error', "Generic bzr smart protocol error: "
-                "bad request u'%s'" % REQUEST_NAME)):
-            protocol.cancel_read_body()
-            self._ensure_real()
-            return self._real_repository.get_data_stream_for_search(search)
         else:
             raise errors.UnexpectedSmartServerResponse(response)
 
@@ -1037,6 +1106,17 @@
     def _make_parents_provider(self):
         return self
 
+    def _serialise_search_recipe(self, recipe):
+        """Serialise a graph search recipe.
+
+        :param recipe: A search recipe (start, stop, count).
+        :return: Serialised bytes.
+        """
+        start_keys = ' '.join(recipe[0])
+        stop_keys = ' '.join(recipe[1])
+        count = str(recipe[2])
+        return '\n'.join((start_keys, stop_keys, count))
+
 
 class RemoteBranchLockableFiles(LockableFiles):
     """A 'LockableFiles' implementation that talks to a smart server.

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2008-01-29 06:56:51 +0000
+++ bzrlib/repository.py	2008-02-04 22:01:14 +0000
@@ -1778,8 +1778,7 @@
         """Return the graph walker for this repository format"""
         parents_provider = self._make_parents_provider()
         if (other_repository is not None and
-            other_repository.bzrdir.transport.base !=
-            self.bzrdir.transport.base):
+            not self.has_same_location(other_repository)):
             parents_provider = graph._StackedParentsProvider(
                 [parents_provider, other_repository._make_parents_provider()])
         return graph.Graph(parents_provider)

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2008-01-22 06:56:59 +0000
+++ bzrlib/smart/medium.py	2008-02-06 03:52:25 +0000
@@ -386,6 +386,10 @@
 
     def __init__(self):
         self._current_request = None
+        # Be optimistic: we assume the remote end can accept new remote
+        # requests until we get an error saying otherwise.  (1.2 adds some
+        # requests that send bodies, which confuses older servers.)
+        self._remote_is_at_least_1_2 = True
 
     def accept_bytes(self, bytes):
         self._accept_bytes(bytes)

=== modified file 'bzrlib/smart/protocol.py'
--- bzrlib/smart/protocol.py	2008-01-21 23:04:54 +0000
+++ bzrlib/smart/protocol.py	2008-02-03 22:55:08 +0000
@@ -488,6 +488,8 @@
                 mutter('                  (to %s)', self._request._medium._path)
             mutter('              %d bytes', len(body))
             self._request_start_time = time.time()
+            if 'hpssdetail' in debug.debug_flags:
+                mutter('hpss body content: %s', body)
         self._write_args(args)
         bytes = self._encode_bulk_data(body)
         self._request.accept_bytes(bytes)

=== modified file 'bzrlib/smart/repository.py'
--- bzrlib/smart/repository.py	2008-01-17 07:47:52 +0000
+++ bzrlib/smart/repository.py	2008-02-05 22:42:47 +0000
@@ -16,6 +16,7 @@
 
 """Server-side repository related request implmentations."""
 
+import bz2
 from cStringIO import StringIO
 import os
 import sys
@@ -58,29 +59,77 @@
         # is expected)
         return None
 
+    def recreate_search(self, repository, recipe_bytes):
+        lines = recipe_bytes.split('\n')
+        start_keys = set(lines[0].split(' '))
+        exclude_keys = set(lines[1].split(' '))
+        revision_count = int(lines[2])
+        repository.lock_read()
+        try:
+            search = repository.get_graph()._make_breadth_first_searcher(
+                start_keys)
+            while True:
+                try:
+                    next_revs = search.next()
+                except StopIteration:
+                    break
+                search.stop_searching_any(exclude_keys.intersection(next_revs))
+            search_result = search.get_result()
+            if search_result.get_recipe()[2] != revision_count:
+                # we got back a different amount of data than expected, this
+                # gets reported as NoSuchRevision, because less revisions
+                # indicates missing revisions, and more should never happen as
+                # the excludes list considers ghosts and ensures that ghost
+                # filling races are not a problem.
+                return (None, FailedSmartServerResponse(('NoSuchRevision',)))
+            return (search, None)
+        finally:
+            repository.unlock()
+
 
 class SmartServerRepositoryGetParentMap(SmartServerRepositoryRequest):
+    """Bzr 1.2+ - get parent data for revisions during a graph search."""
     
     def do_repository_request(self, repository, *revision_ids):
-        repository.lock_read()
-        try:
-            return self._do_repository_request(repository, revision_ids)
-        finally:
-            repository.unlock()
-
-    def _do_repository_request(self, repository, revision_ids):
         """Get parent details for some revisions.
         
         All the parents for revision_ids are returned. Additionally up to 64KB
         of additional parent data found by performing a breadth first search
-        from revision_ids is returned.
+        from revision_ids is returned. The verb takes a body containing the
+        current search state, see do_body for details.
 
         :param repository: The repository to query in.
         :param revision_ids: The utf8 encoded revision_id to answer for.
+        """
+        self._revision_ids = revision_ids
+        return None # Signal that we want a body.
+
+    def do_body(self, body_bytes):
+        """Process the current search state and perform the parent lookup.
+
         :return: A smart server response where the body contains an utf8
-            encoded flattened list of the parents of the revisions, (the same
-            format as Repository.get_revision_graph).
+            encoded flattened list of the parents of the revisions (the same
+            format as Repository.get_revision_graph) which has been bz2
+            compressed.
         """
+        repository = self._repository
+        repository.lock_read()
+        try:
+            return self._do_repository_request(body_bytes)
+        finally:
+            repository.unlock()
+
+    def _do_repository_request(self, body_bytes):
+        repository = self._repository
+        revision_ids = set(self._revision_ids)
+        search, error = self.recreate_search(repository, body_bytes)
+        if error is not None:
+            return error
+        # TODO might be nice to start up the search again; but thats not
+        # written or tested yet.
+        client_seen_revs = set(search.get_result().get_keys())
+        # Always include the requested ids.
+        client_seen_revs.difference_update(revision_ids)
         lines = []
         repo_graph = repository.get_graph()
         result = {}
@@ -96,25 +145,32 @@
                 # adjust for the wire
                 if parents == (_mod_revision.NULL_REVISION,):
                     parents = ()
-                # add parents to the result
-                result[revision_id] = parents
                 # prepare the next query
                 next_revs.update(parents)
-                # Approximate the serialized cost of this revision_id.
-                size_so_far += 2 + len(revision_id) + sum(map(len, parents))
-                # get all the directly asked for parents, and then flesh out to
-                # 64K or so.
-                if first_loop_done and size_so_far > 65000:
-                    next_revs = set()
-                    break
+                if revision_id not in client_seen_revs:
+                    # Client does not have this revision, give it to it.
+                    # add parents to the result
+                    result[revision_id] = parents
+                    # Approximate the serialized cost of this revision_id.
+                    size_so_far += 2 + len(revision_id) + sum(map(len, parents))
+            # get all the directly asked for parents, and then flesh out to
+            # 64K (compressed) or so. We do one level of depth at a time to
+            # stay in sync with the client. The 250000 magic number is
+            # estimated compression ratio taken from bzr.dev itself.
+            if first_loop_done and size_so_far > 250000:
+                next_revs = set()
+                break
             # don't query things we've already queried
             next_revs.difference_update(queried_revs)
             first_loop_done = True
 
-        for revision, parents in result.items():
+        # sorting trivially puts lexographically similar revision ids together.
+        # Compression FTW.
+        for revision, parents in sorted(result.items()):
             lines.append(' '.join((revision, ) + tuple(parents)))
 
-        return SuccessfulSmartServerResponse(('ok', ), '\n'.join(lines))
+        return SuccessfulSmartServerResponse(
+            ('ok', ), bz2.compress('\n'.join(lines)))
 
 
 class SmartServerRepositoryGetRevisionGraph(SmartServerRepositoryRequest):
@@ -342,31 +398,15 @@
     """Bzr 1.1+ streaming pull."""
 
     def do_body(self, body_bytes):
-        lines = body_bytes.split('\n')
-        start_keys = set(lines[0].split(' '))
-        exclude_keys = set(lines[1].split(' '))
-        revision_count = int(lines[2])
         repository = self._repository
         repository.lock_read()
         try:
-            search = repository.get_graph()._make_breadth_first_searcher(
-                start_keys)
-            while True:
-                try:
-                    next_revs = search.next()
-                except StopIteration:
-                    break
-                search.stop_searching_any(exclude_keys.intersection(next_revs))
-            search_result = search.get_result()
-            if search_result.get_recipe()[2] != revision_count:
-                # we got back a different amount of data than expected, this
-                # gets reported as NoSuchRevision, because less revisions
-                # indicates missing revisions, and more should never happen as
-                # the excludes list considers ghosts and ensures that ghost
-                # filling races are not a problem.
-                return FailedSmartServerResponse(('NoSuchRevision',))
-            stream = repository.get_data_stream_for_search(search_result)
+            search, error = self.recreate_search(repository, body_bytes)
+            if error is not None:
+                return error
+            stream = repository.get_data_stream_for_search(search.get_result())
         except Exception:
+            # On non-error, unlocking is done by the body stream handler.
             repository.unlock()
             raise
         return SuccessfulSmartServerResponse(('ok',),

=== modified file 'bzrlib/symbol_versioning.py'
--- bzrlib/symbol_versioning.py	2008-01-17 03:14:20 +0000
+++ bzrlib/symbol_versioning.py	2008-02-13 03:25:53 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com> and others
 #
 # This program is free software; you can redistribute it and/or modify
@@ -44,6 +44,7 @@
            'one_zero',
            'one_one',
            'one_two',
+           'one_three',
            ]
 
 from warnings import warn
@@ -69,6 +70,7 @@
 zero_ninetythree = one_zero # Maintained for backwards compatibility
 one_one = "%s was deprecated in version 1.1."
 one_two = "%s was deprecated in version 1.2."
+one_three = "%s was deprecated in version 1.3."
 
 def set_warning_method(method):
     """Set the warning method to be used by this module.

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2008-02-06 10:07:17 +0000
+++ bzrlib/tests/__init__.py	2008-02-16 10:03:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -797,7 +797,6 @@
     def setUp(self):
         unittest.TestCase.setUp(self)
         self._cleanEnvironment()
-        bzrlib.trace.disable_default_logging()
         self._silenceUI()
         self._startLogFile()
         self._benchcalls = []
@@ -1041,6 +1040,32 @@
         else:
             self.fail('Unexpected success.  Should have failed: %s' % reason)
 
+    def assertFileEqual(self, content, path):
+        """Fail if path does not contain 'content'."""
+        self.failUnlessExists(path)
+        f = file(path, 'rb')
+        try:
+            s = f.read()
+        finally:
+            f.close()
+        self.assertEqualDiff(content, s)
+
+    def failUnlessExists(self, path):
+        """Fail unless path or paths, which may be abs or relative, exist."""
+        if not isinstance(path, basestring):
+            for p in path:
+                self.failUnlessExists(p)
+        else:
+            self.failUnless(osutils.lexists(path),path+" does not exist")
+
+    def failIfExists(self, path):
+        """Fail if path or paths, which may be abs or relative, exist."""
+        if not isinstance(path, basestring):
+            for p in path:
+                self.failIfExists(p)
+        else:
+            self.failIf(osutils.lexists(path),path+" exists")
+
     def _capture_deprecation_warnings(self, a_callable, *args, **kwargs):
         """A helper for callDeprecated and applyDeprecated.
 
@@ -1159,7 +1184,7 @@
         """
         fileno, name = tempfile.mkstemp(suffix='.log', prefix='testbzr')
         self._log_file = os.fdopen(fileno, 'w+')
-        self._log_nonce = bzrlib.trace.enable_test_log(self._log_file)
+        self._log_memento = bzrlib.trace.push_log_file(self._log_file)
         self._log_file_name = name
         self.addCleanup(self._finishLogFile)
 
@@ -1170,7 +1195,7 @@
         """
         if self._log_file is None:
             return
-        bzrlib.trace.disable_test_log(self._log_nonce)
+        bzrlib.trace.pop_log_file(self._log_memento)
         self._log_file.close()
         self._log_file = None
         if not self._keep_log_file:
@@ -2089,32 +2114,6 @@
     def build_tree_contents(self, shape):
         build_tree_contents(shape)
 
-    def assertFileEqual(self, content, path):
-        """Fail if path does not contain 'content'."""
-        self.failUnlessExists(path)
-        f = file(path, 'rb')
-        try:
-            s = f.read()
-        finally:
-            f.close()
-        self.assertEqualDiff(content, s)
-
-    def failUnlessExists(self, path):
-        """Fail unless path or paths, which may be abs or relative, exist."""
-        if not isinstance(path, basestring):
-            for p in path:
-                self.failUnlessExists(p)
-        else:
-            self.failUnless(osutils.lexists(path),path+" does not exist")
-
-    def failIfExists(self, path):
-        """Fail if path or paths, which may be abs or relative, exist."""
-        if not isinstance(path, basestring):
-            for p in path:
-                self.failIfExists(p)
-        else:
-            self.failIf(osutils.lexists(path),path+" exists")
-
     def assertInWorkingTree(self, path, root_path='.', tree=None):
         """Assert whether path or paths are in the WorkingTree"""
         if tree is None:

=== modified file 'bzrlib/tests/blackbox/test_bundle_info.py'
--- bzrlib/tests/blackbox/test_bundle_info.py	2007-08-16 18:23:13 +0000
+++ bzrlib/tests/blackbox/test_bundle_info.py	2008-02-13 01:31:33 +0000
@@ -38,7 +38,7 @@
         self.assertContainsRe(info, 'file: 1 .0 multiparent.')
         self.assertContainsRe(info, 'nicks: source')
         self.assertNotContainsRe(info, 'foo')
-        self.run_bzr_error(['Verbose requires a merge directive'],
+        self.run_bzr_error(['--verbose requires a merge directive'],
                            'bundle-info -v bundle')
         target = self.make_branch('target')
         md = merge_directive.MergeDirective2.from_objects(

=== modified file 'bzrlib/tests/blackbox/test_version_info.py'
--- bzrlib/tests/blackbox/test_version_info.py	2007-06-26 20:32:49 +0000
+++ bzrlib/tests/blackbox/test_version_info.py	2008-01-30 15:54:33 +0000
@@ -134,3 +134,8 @@
         txt = self.run_bzr('version-info --format python branch')[0]
 
         self.assertContainsRe(txt, 'version_info = {')
+
+    def test_custom_without_template(self):
+        wt = self.make_branch_and_tree('branch')
+        out, err = self.run_bzr('version-info --custom', retcode=3)
+        self.assertContainsRe(err, r'ERROR: No template specified\.')

=== modified file 'bzrlib/tests/test_dirstate.py'
--- bzrlib/tests/test_dirstate.py	2007-11-21 22:16:20 +0000
+++ bzrlib/tests/test_dirstate.py	2008-02-13 01:35:27 +0000
@@ -646,6 +646,45 @@
         finally:
             state.unlock()
 
+    def test_save_refuses_if_changes_aborted(self):
+        self.build_tree(['a-file', 'a-dir/'])
+        state = dirstate.DirState.initialize('dirstate')
+        try:
+            # No stat and no sha1 sum.
+            state.add('a-file', 'a-file-id', 'file', None, '')
+            state.save()
+        finally:
+            state.unlock()
+
+        # The dirstate should include TREE_ROOT and 'a-file' and nothing else
+        expected_blocks = [
+            ('', [(('', '', 'TREE_ROOT'),
+                   [('d', '', 0, False, dirstate.DirState.NULLSTAT)])]),
+            ('', [(('', 'a-file', 'a-file-id'),
+                   [('f', '', 0, False, dirstate.DirState.NULLSTAT)])]),
+        ]
+
+        state = dirstate.DirState.on_file('dirstate')
+        state.lock_write()
+        try:
+            state._read_dirblocks_if_needed()
+            self.assertEqual(expected_blocks, state._dirblocks)
+
+            # Now modify the state, but mark it as inconsistent
+            state.add('a-dir', 'a-dir-id', 'directory', None, '')
+            state._changes_aborted = True
+            state.save()
+        finally:
+            state.unlock()
+
+        state = dirstate.DirState.on_file('dirstate')
+        state.lock_read()
+        try:
+            state._read_dirblocks_if_needed()
+            self.assertEqual(expected_blocks, state._dirblocks)
+        finally:
+            state.unlock()
+
 
 class TestDirStateInitialize(TestCaseWithDirState):
 

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2008-01-25 10:46:10 +0000
+++ bzrlib/tests/test_errors.py	2008-02-13 01:42:47 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #   Authors: Robert Collins <robert.collins@canonical.com>
 #            and others
 #
@@ -29,6 +29,13 @@
 
 class TestErrors(TestCaseWithTransport):
 
+    def test_corrupt_dirstate(self):
+        error = errors.CorruptDirstate('path/to/dirstate', 'the reason why')
+        self.assertEqualDiff(
+            "Inconsistency in dirstate file path/to/dirstate.\n"
+            "Error: the reason why",
+            str(error))
+
     def test_disabled_method(self):
         error = errors.DisabledMethod("class name")
         self.assertEqualDiff(
@@ -51,6 +58,13 @@
             'It supports versions "(4, 5, 6)" to "(7, 8, 9)".',
             str(error))
 
+    def test_inconsistent_delta(self):
+        error = errors.InconsistentDelta('path', 'file-id', 'reason for foo')
+        self.assertEqualDiff(
+            "An inconsistent delta was supplied involving 'path', 'file-id'\n"
+            "reason: reason for foo",
+            str(error))
+
     def test_in_process_transport(self):
         error = errors.InProcessTransport('fpp')
         self.assertEqualDiff(

=== modified file 'bzrlib/tests/test_progress.py'
--- bzrlib/tests/test_progress.py	2007-12-30 18:20:15 +0000
+++ bzrlib/tests/test_progress.py	2008-02-13 03:30:01 +0000
@@ -30,6 +30,7 @@
 
 
 class FakeStack:
+
     def __init__(self, top):
         self.__top = top
 
@@ -52,6 +53,7 @@
 
 
 class TestProgress(TestCase):
+
     def setUp(self):
         q = DummyProgress()
         self.top = ChildProgress(_stack=FakeStack(q))

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2008-01-22 00:27:42 +0000
+++ bzrlib/tests/test_remote.py	2008-02-07 03:47:24 +0000
@@ -23,6 +23,7 @@
 These tests correspond to tests.test_smart, which exercises the server side.
 """
 
+import bz2
 from cStringIO import StringIO
 
 from bzrlib import (
@@ -139,7 +140,7 @@
         self.responses = responses
         self._calls = []
         self.expecting_body = False
-        _SmartClient.__init__(self, FakeMedium(fake_medium_base))
+        _SmartClient.__init__(self, FakeMedium(fake_medium_base, self._calls))
 
     def call(self, method, *args):
         self._calls.append(('call', method, args))
@@ -161,8 +162,20 @@
 
 class FakeMedium(object):
 
-    def __init__(self, base):
+    def __init__(self, base, client_calls):
         self.base = base
+        self.connection = FakeConnection(client_calls)
+        self._client_calls = client_calls
+
+
+class FakeConnection(object):
+
+    def __init__(self, client_calls):
+        self._remote_is_at_least_1_2 = True
+        self._client_calls = client_calls
+
+    def disconnect(self):
+        self._client_calls.append(('disconnect medium',))
 
 
 class TestVfsHas(tests.TestCase):
@@ -206,6 +219,23 @@
             [('call', 'BzrDir.open_branch', ('quack/',))],
             client._calls)
 
+    def test__get_tree_branch(self):
+        # _get_tree_branch is a form of open_branch, but it should only ask for
+        # branch opening, not any other network requests.
+        calls = []
+        def open_branch():
+            calls.append("Called")
+            return "a-branch"
+        transport = MemoryTransport()
+        # no requests on the network - catches other api calls being made.
+        client = FakeClient([], transport.base)
+        bzrdir = RemoteBzrDir(transport, _client=client)
+        # patch the open_branch call to record that it was called.
+        bzrdir.open_branch = open_branch
+        self.assertEqual((None, "a-branch"), bzrdir._get_tree_branch())
+        self.assertEqual(["Called"], calls)
+        self.assertEqual([], client._calls)
+
     def test_url_quoting_of_path(self):
         # Relpaths on the wire should not be URL-escaped.  So "~" should be
         # transmitted as "~", not "%7E".
@@ -608,7 +638,7 @@
         r1 = u'\u0e33'.encode('utf8')
         r2 = u'\u0dab'.encode('utf8')
         lines = [' '.join([r2, r1]), r1]
-        encoded_body = '\n'.join(lines)
+        encoded_body = bz2.compress('\n'.join(lines))
         responses = [(('ok', ), encoded_body), (('ok', ), encoded_body)]
 
         transport_path = 'quack'
@@ -624,8 +654,8 @@
         parents = graph.get_parent_map([r1])
         self.assertEqual({r1: (NULL_REVISION,)}, parents)
         self.assertEqual(
-            [('call_expecting_body', 'Repository.get_parent_map',
-             ('quack/', r2))],
+            [('call_with_body_bytes_expecting_body',
+              'Repository.get_parent_map', ('quack/', r2), '\n\n0')],
             client._calls)
         repo.unlock()
         # now we call again, and it should use the second response.
@@ -634,14 +664,35 @@
         parents = graph.get_parent_map([r1])
         self.assertEqual({r1: (NULL_REVISION,)}, parents)
         self.assertEqual(
-            [('call_expecting_body', 'Repository.get_parent_map',
-              ('quack/', r2)),
-             ('call_expecting_body', 'Repository.get_parent_map',
-              ('quack/', r1))
+            [('call_with_body_bytes_expecting_body',
+              'Repository.get_parent_map', ('quack/', r2), '\n\n0'),
+             ('call_with_body_bytes_expecting_body',
+              'Repository.get_parent_map', ('quack/', r1), '\n\n0'),
             ],
             client._calls)
         repo.unlock()
 
+    def test_get_parent_map_reconnects_if_unknown_method(self):
+        error_msg = (
+            "Generic bzr smart protocol error: "
+            "bad request 'Repository.get_parent_map'")
+        responses = [
+            (('error', error_msg), ''),
+            (('ok',), '')]
+        transport_path = 'quack'
+        repo, client = self.setup_fake_client_and_repository(
+            responses, transport_path)
+        rev_id = 'revision-id'
+        parents = repo.get_parent_map([rev_id])
+        self.assertEqual(
+            [('call_with_body_bytes_expecting_body',
+              'Repository.get_parent_map', ('quack/', rev_id), '\n\n0'),
+             ('disconnect medium',),
+             ('call_expecting_body', 'Repository.get_revision_graph',
+              ('quack/', ''))],
+            client._calls)
+
+
 
 class TestRepositoryGetRevisionGraph(TestRemoteRepository):
     

=== modified file 'bzrlib/tests/test_revisionnamespaces.py'
--- bzrlib/tests/test_revisionnamespaces.py	2007-08-06 22:26:54 +0000
+++ bzrlib/tests/test_revisionnamespaces.py	2007-11-27 00:44:20 +0000
@@ -350,10 +350,8 @@
     
     def make_branch_and_tree(self, relpath):
         # override format as the default one may not support tags
-        control = bzrdir.BzrDir.create(relpath)
-        control.create_repository()
-        branch.BzrBranchExperimental.initialize(control)
-        return control.create_workingtree()
+        return TestRevisionSpec.make_branch_and_tree(
+            self, relpath, format='dirstate-tags')
 
     def test_from_string_tag(self):
         spec = RevisionSpec.from_string('tag:bzr-0.14')

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2008-01-17 07:49:09 +0000
+++ bzrlib/tests/test_smart.py	2008-02-05 22:42:47 +0000
@@ -24,6 +24,7 @@
 Tests for low-level protocol encoding are found in test_smart_transport.
 """
 
+import bz2
 from StringIO import StringIO
 import tempfile
 import tarfile
@@ -529,6 +530,22 @@
             request.execute, backing.local_abspath('subdir'))
 
 
+class TestSmartServerRepositoryGetParentMap(tests.TestCaseWithTransport):
+
+    def test_trivial_bzipped(self):
+        # This tests that the wire encoding is actually bzipped
+        backing = self.get_transport()
+        request = smart.repository.SmartServerRepositoryGetParentMap(backing)
+        tree = self.make_branch_and_memory_tree('.')
+
+        self.assertEqual(None,
+            request.execute(backing.local_abspath(''), 'missing-id'))
+        # Note that it returns a body (of '' bzipped).
+        self.assertEqual(
+            SuccessfulSmartServerResponse(('ok', ), bz2.compress('')),
+            request.do_body('\n\n0\n'))
+
+
 class TestSmartServerRepositoryGetRevisionGraph(tests.TestCaseWithTransport):
 
     def test_none_argument(self):

=== modified file 'bzrlib/tests/test_trace.py'
--- bzrlib/tests/test_trace.py	2008-01-22 05:00:42 +0000
+++ bzrlib/tests/test_trace.py	2008-02-07 03:49:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -23,6 +23,7 @@
 import os
 import re
 import sys
+import tempfile
 
 from bzrlib import (
     errors,
@@ -31,6 +32,8 @@
 from bzrlib.trace import (
     mutter, mutter_callsite, report_exception,
     set_verbosity_level, get_verbosity_level, is_quiet, is_verbose, be_quiet,
+    pop_log_file,
+    push_log_file,
     _rollover_trace_maybe,
     )
 
@@ -158,6 +161,39 @@
         self.assertContainsRe(log, "But fails in an ascii string")
         self.assertContainsRe(log, u"ascii argument: \xb5")
 
+    def test_push_log_file(self):
+        """Can push and pop log file, and this catches mutter messages.
+
+        This is primarily for use in the test framework. 
+        """
+        tmp1 = tempfile.NamedTemporaryFile()
+        tmp2 = tempfile.NamedTemporaryFile()
+        try:
+            memento1 = push_log_file(tmp1)
+            mutter("comment to file1")
+            try:
+                memento2 = push_log_file(tmp2)
+                try:
+                    mutter("comment to file2")
+                finally:
+                    pop_log_file(memento2)
+                mutter("again to file1")
+            finally:
+                pop_log_file(memento1)
+            # the files were opened in binary mode, so should have exactly
+            # these bytes.  and removing the file as the log target should
+            # have caused them to be flushed out.  need to match using regexps
+            # as there's a timestamp at the front.
+            tmp1.seek(0)
+            self.assertContainsRe(tmp1.read(),
+                r"\d+\.\d+  comment to file1\n\d+\.\d+  again to file1\n")
+            tmp2.seek(0)
+            self.assertContainsRe(tmp2.read(),
+                r"\d+\.\d+  comment to file2\n")
+        finally:
+            tmp1.close()
+            tmp2.close()
+
 
 class TestVerbosityLevel(TestCase):
 

=== modified file 'bzrlib/tests/test_version_info.py'
--- bzrlib/tests/test_version_info.py	2007-12-21 15:05:25 +0000
+++ bzrlib/tests/test_version_info.py	2008-01-30 15:54:33 +0000
@@ -22,6 +22,7 @@
 import sys
 
 from bzrlib import (
+    errors,
     symbol_versioning,
     tests,
     version_info_formats,
@@ -257,6 +258,11 @@
         self.assertEqual(val, 'clean: 0')
         os.remove('branch/c')
 
+    def test_custom_without_template(self):
+        builder = CustomVersionInfoBuilder(None)
+        sio = StringIO()
+        self.assertRaises(errors.NoTemplate, builder.generate, sio)
+
 
 class TestBuilder(version_info_formats.VersionInfoBuilder):
     pass

=== modified file 'bzrlib/tests/test_workingtree_4.py'
--- bzrlib/tests/test_workingtree_4.py	2007-09-17 05:33:56 +0000
+++ bzrlib/tests/test_workingtree_4.py	2008-02-04 21:12:49 +0000
@@ -574,3 +574,99 @@
         changes = [c[1] for c in tree._iter_changes(basis)]
         self.assertEqual([], changes)
         self.assertEqual(['', 'versioned', 'versioned2'], returned)
+
+
+class TestCorruptDirstate(TestCaseWithTransport):
+    """Tests for how we handle when the dirstate has been corrupted."""
+
+    def create_wt4(self):
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        control.create_repository()
+        control.create_branch()
+        tree = workingtree_4.WorkingTreeFormat4().initialize(control)
+        return tree
+
+    def test_invalid_rename(self):
+        tree = self.create_wt4()
+        # Create a corrupted dirstate
+        tree.lock_write()
+        try:
+            tree.commit('init') # We need a parent, or we always compare with NULL
+            state = tree.current_dirstate()
+            state._read_dirblocks_if_needed()
+            # Now add in an invalid entry, a rename with a dangling pointer
+            state._dirblocks[1][1].append((('', 'foo', 'foo-id'),
+                                            [('f', '', 0, False, ''),
+                                             ('r', 'bar', 0 , False, '')]))
+            self.assertListRaises(errors.CorruptDirstate,
+                                  tree._iter_changes, tree.basis_tree())
+        finally:
+            tree.unlock()
+
+    def get_simple_dirblocks(self, state):
+        """Extract the simple information from the DirState.
+
+        This returns the dirblocks, only with the sha1sum and stat details
+        filtered out.
+        """
+        simple_blocks = []
+        for block in state._dirblocks:
+            simple_block = (block[0], [])
+            for entry in block[1]:
+                # Include the key for each entry, and for each parent include
+                # just the minikind, so we know if it was
+                # present/absent/renamed/etc
+                simple_block[1].append((entry[0], [i[0] for i in entry[1]]))
+            simple_blocks.append(simple_block)
+        return simple_blocks
+
+    def test_update_basis_with_invalid_delta(self):
+        """When given an invalid delta, it should abort, and not be saved."""
+        self.build_tree(['dir/', 'dir/file'])
+        tree = self.create_wt4()
+        tree.lock_write()
+        self.addCleanup(tree.unlock)
+        tree.add(['dir', 'dir/file'], ['dir-id', 'file-id'])
+        first_revision_id = tree.commit('init')
+
+        root_id = tree.path2id('')
+        state = tree.current_dirstate()
+        state._read_dirblocks_if_needed()
+        self.assertEqual([
+            ('', [(('', '', root_id), ['d', 'd'])]),
+            ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
+            ('dir', [(('dir', 'file', 'file-id'), ['f', 'f'])]),
+        ],  self.get_simple_dirblocks(state))
+
+        tree.remove(['dir/file'])
+        self.assertEqual([
+            ('', [(('', '', root_id), ['d', 'd'])]),
+            ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
+            ('dir', [(('dir', 'file', 'file-id'), ['a', 'f'])]),
+        ],  self.get_simple_dirblocks(state))
+        # Make sure the removal is written to disk
+        tree.flush()
+
+        # self.assertRaises(Exception, tree.update_basis_by_delta,
+        new_dir = inventory.InventoryDirectory('dir-id', 'new-dir', root_id)
+        new_dir.revision = 'new-revision-id'
+        new_file = inventory.InventoryFile('file-id', 'new-file', root_id)
+        new_file.revision = 'new-revision-id'
+        self.assertRaises(errors.InconsistentDelta,
+            tree.update_basis_by_delta, 'new-revision-id',
+            [('dir', 'new-dir', 'dir-id', new_dir),
+             ('dir/file', 'new-dir/new-file', 'file-id', new_file),
+            ])
+        del state
+
+        # Now when we re-read the file it should not have been modified
+        tree.unlock()
+        tree.lock_read()
+        self.assertEqual(first_revision_id, tree.last_revision())
+        state = tree.current_dirstate()
+        state._read_dirblocks_if_needed()
+        self.assertEqual([
+            ('', [(('', '', root_id), ['d', 'd'])]),
+            ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
+            ('dir', [(('dir', 'file', 'file-id'), ['a', 'f'])]),
+        ],  self.get_simple_dirblocks(state))

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2008-02-07 08:47:27 +0000
+++ bzrlib/trace.py	2008-02-16 10:03:17 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006, 2007 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -49,6 +49,11 @@
 # FIXME: Unfortunately it turns out that python's logging module
 # is quite expensive, even when the message is not printed by any handlers.
 # We should perhaps change back to just simply doing it here.
+#
+# On the other hand, as of 1.2 we generally only call the mutter() statement
+# if (according to debug_flags) we actually intend to write it.  So the
+# increased cost of logging.py is not so bad, and we could standardize on
+# that.
 
 import codecs
 import logging
@@ -73,35 +78,54 @@
     errors,
     osutils,
     plugin,
+    symbol_versioning,
     )
 """)
 
-_file_handler = None
-_stderr_handler = None
+
+# global verbosity for bzrlib; controls the log level for stderr; 0=normal; <0
+# is quiet; >0 is verbose.
 _verbosity_level = 0
+
+# File-like object where mutter/debug output is currently sent.  Can be
+# changed by _push_log_file etc.  This is directly manipulated by some
+# external code; maybe there should be functions to do that more precisely
+# than push/pop_log_file.
 _trace_file = None
-_trace_depth = 0
-_bzr_log_file = None
+
+# Absolute path for ~/.bzr.log.  Not changed even if the log/trace output is
+# redirected elsewhere.  Used to show the location in --version.
 _bzr_log_filename = None
-_start_time = bzrlib._start_time
-
-
-# configure convenient aliases for output routines
-
+
+# The time the first message was written to the trace file, so that we can
+# show relative times since startup.
+_bzr_log_start_time = bzrlib._start_time
+
+
+# held in a global for quick reference
 _bzr_logger = logging.getLogger('bzr')
 
 
 def note(*args, **kwargs):
     # FIXME note always emits utf-8, regardless of the terminal encoding
+    #
+    # FIXME: clearing the ui and then going through the abstract logging
+    # framework is whack; we should probably have a logging Handler that
+    # deals with terminal output if needed.
     import bzrlib.ui
     bzrlib.ui.ui_factory.clear_term()
     _bzr_logger.info(*args, **kwargs)
 
+
 def warning(*args, **kwargs):
     import bzrlib.ui
     bzrlib.ui.ui_factory.clear_term()
     _bzr_logger.warning(*args, **kwargs)
 
+
+# configure convenient aliases for output routines
+#
+# TODO: deprecate them, have one name for each.
 info = note
 log_error = _bzr_logger.error
 error =     _bzr_logger.error
@@ -128,11 +152,11 @@
         out = fmt % tuple(real_args)
     else:
         out = fmt
-    timestamp = '%0.3f  ' % (time.time() - _start_time,)
+    timestamp = '%0.3f  ' % (time.time() - _bzr_log_start_time,)
     out = timestamp + out + '\n'
     _trace_file.write(out)
-    # TODO: jam 20051227 Consider flushing the trace file to help debugging
-    #_trace_file.flush()
+    # no need to flush here, the trace file is now linebuffered when it's
+    # opened.
 
 
 def mutter_callsite(stacklevel, fmt, *args):
@@ -162,46 +186,140 @@
         return
 
 
-def open_tracefile(tracefilename=None):
-    # Messages are always written to here, so that we have some
-    # information if something goes wrong.  In a future version this
-    # file will be removed on successful completion.
-    global _file_handler, _bzr_log_file, _bzr_log_filename
-    import codecs
-
-    if tracefilename is None:
-        home = os.environ.get('BZR_HOME')
-        if home is None:
-            if sys.platform == 'win32':
-                from bzrlib import win32utils
-                home = win32utils.get_home_location()
-            else:
-                home = os.path.expanduser('~')
-        _bzr_log_filename = os.path.join(home, '.bzr.log')
-    else:
-        _bzr_log_filename = tracefilename
-
-    _bzr_log_filename = os.path.expanduser(_bzr_log_filename)
+def _get_bzr_log_filename():
+    bzr_log = os.environ.get('BZR_LOG')
+    if bzr_log:
+        return bzr_log
+    home = os.environ.get('BZR_HOME')
+    if home is None:
+        if sys.platform == 'win32':
+            from bzrlib import win32utils
+            home = win32utils.get_home_location()
+        else:
+            home = os.path.expanduser('~')
+    return os.path.join(home, '.bzr.log')
+
+
+def _open_bzr_log():
+    """Open the .bzr.log trace file.  
+
+    If the log is more than a particular length, the old file is renamed to
+    .bzr.log.old and a new file is started.  Otherwise, we append to the
+    existing file.
+
+    This sets the global _bzr_log_filename.
+    """
+    global _bzr_log_filename
+    _bzr_log_filename = _get_bzr_log_filename()
     _rollover_trace_maybe(_bzr_log_filename)
     try:
-        LINE_BUFFERED = 1
-        #tf = codecs.open(trace_fname, 'at', 'utf8', buffering=LINE_BUFFERED)
-        tf = open(_bzr_log_filename, 'at', LINE_BUFFERED)
-        _bzr_log_file = tf
-        # tf.tell() on windows always return 0 until some writing done
-        tf.write('\n')
-        if tf.tell() <= 2:
-            tf.write("this is a debug log for diagnosing/reporting problems in bzr\n")
-            tf.write("you can delete or truncate this file, or include sections in\n")
-            tf.write("bug reports to https://bugs.launchpad.net/bzr/+filebug\n\n")
-        _file_handler = logging.StreamHandler(tf)
-        fmt = r'[%(process)5d] %(asctime)s.%(msecs)03d %(levelname)s: %(message)s'
-        datefmt = r'%Y-%m-%d %H:%M:%S'
-        _file_handler.setFormatter(logging.Formatter(fmt, datefmt))
-        _file_handler.setLevel(logging.DEBUG)
-        logging.getLogger('').addHandler(_file_handler)
+        bzr_log_file = open(_bzr_log_filename, 'at', 1) # line buffered
+        # bzr_log_file.tell() on windows always return 0 until some writing done
+        bzr_log_file.write('\n')
+        if bzr_log_file.tell() <= 2:
+            bzr_log_file.write("this is a debug log for diagnosing/reporting problems in bzr\n")
+            bzr_log_file.write("you can delete or truncate this file, or include sections in\n")
+            bzr_log_file.write("bug reports to https://bugs.launchpad.net/bzr/+filebug\n\n")
+        return bzr_log_file
     except IOError, e:
         warning("failed to open trace file: %s" % (e))
+    # TODO: What should happen if we fail to open the trace file?  Maybe the
+    # objects should be pointed at /dev/null or the equivalent?  Currently
+    # returns None which will cause failures later.
+
+
+def enable_default_logging():
+    """Configure default logging: messages to stderr and debug to .bzr.log
+    
+    This should only be called once per process.
+
+    Non-command-line programs embedding bzrlib do not need to call this.  They
+    can instead either pass a file to _push_log_file, or act directly on
+    logging.getLogger("bzr").
+    
+    Output can be redirected away by calling _push_log_file.
+    """
+    # create encoded wrapper around stderr
+    bzr_log_file = _open_bzr_log()
+    push_log_file(bzr_log_file,
+        r'[%(process)5d] %(asctime)s.%(msecs)03d %(levelname)s: %(message)s',
+        r'%Y-%m-%d %H:%M:%S')
+    # after hooking output into bzr_log, we also need to attach a stderr
+    # handler, writing only at level info and with encoding
+    writer_factory = codecs.getwriter(osutils.get_terminal_encoding())
+    encoded_stderr = writer_factory(sys.stderr, errors='replace')
+    stderr_handler = logging.StreamHandler(encoded_stderr)
+    stderr_handler.setLevel(logging.INFO)
+    logging.getLogger('bzr').addHandler(stderr_handler)
+
+
+def push_log_file(to_file, log_format=None, date_format=None):
+    """Intercept log and trace messages and send them to a file.
+
+    :param to_file: A file-like object to which messages will be sent.
+
+    :returns: A memento that should be passed to _pop_log_file to restore the 
+    previously active logging.
+    """
+    global _trace_file
+    # make a new handler
+    new_handler = logging.StreamHandler(to_file)
+    new_handler.setLevel(logging.DEBUG)
+    if log_format is None:
+        log_format = '%(levelname)8s  %(message)s'
+    new_handler.setFormatter(logging.Formatter(log_format, date_format))
+    # save and remove any existing log handlers
+    bzr_logger = logging.getLogger('bzr')
+    old_handlers = bzr_logger.handlers[:]
+    del bzr_logger.handlers[:]
+    # set that as the default logger
+    bzr_logger.addHandler(new_handler)
+    bzr_logger.setLevel(logging.DEBUG)
+    # TODO: check if any changes are needed to the root logger
+    #
+    # TODO: also probably need to save and restore the level on bzr_logger.
+    # but maybe we can avoid setting the logger level altogether, and just set
+    # the level on the handler?
+    #
+    # save the old trace file
+    old_trace_file = _trace_file
+    # send traces to the new one
+    _trace_file = to_file
+    result = new_handler, _trace_file
+    return ('log_memento', old_handlers, new_handler, old_trace_file, to_file)
+
+
+def pop_log_file((magic, old_handlers, new_handler, old_trace_file, new_trace_file)):
+    """Undo changes to logging/tracing done by _push_log_file.
+
+    This flushes, but does not close the trace file.
+    
+    Takes the memento returned from _push_log_file."""
+    assert magic == 'log_memento'
+    global _trace_file
+    _trace_file = old_trace_file
+    bzr_logger = logging.getLogger('bzr')
+    bzr_logger.removeHandler(new_handler)
+    # must be closed, otherwise logging will try to close it atexit, and the
+    # file will likely already be closed underneath.
+    new_handler.close()
+    bzr_logger.handlers = old_handlers
+    new_trace_file.flush()
+
+
+@symbol_versioning.deprecated_function(symbol_versioning.one_two)
+def enable_test_log(to_file):
+    """Redirect logging to a temporary file for a test
+    
+    :returns: an opaque reference that should be passed to disable_test_log
+    after the test completes.
+    """
+    return push_log_file(to_file)
+
+
+@symbol_versioning.deprecated_function(symbol_versioning.one_two)
+def disable_test_log(memento):
+    return pop_log_file(memento)
 
 
 def log_exception_quietly():
@@ -211,28 +329,9 @@
     interesting to developers but not to users.  For example, 
     errors loading plugins.
     """
-    import traceback
     mutter(traceback.format_exc())
 
 
-def enable_default_logging(tracefilename=None):
-    """Configure default logging to stderr and .bzr.log"""
-    # FIXME: if this is run twice, things get confused
-    global _stderr_handler, _file_handler, _trace_file, _bzr_log_file
-    # create encoded wrapper around stderr
-    stderr = codecs.getwriter(osutils.get_terminal_encoding())(sys.stderr,
-        errors='replace')
-    _stderr_handler = logging.StreamHandler(stderr)
-    logging.getLogger('').addHandler(_stderr_handler)
-    _stderr_handler.setLevel(logging.INFO)
-    if not _file_handler:
-        open_tracefile(tracefilename)
-    _trace_file = _bzr_log_file
-    if _file_handler:
-        _file_handler.setLevel(logging.DEBUG)
-    _bzr_logger.setLevel(logging.DEBUG)
-
-
 def set_verbosity_level(level):
     """Set the verbosity level.
 
@@ -262,9 +361,9 @@
 def _update_logging_level(quiet=True):
     """Hide INFO messages if quiet."""
     if quiet:
-        _stderr_handler.setLevel(logging.WARNING)
+        _bzr_logger.setLevel(logging.WARNING)
     else:
-        _stderr_handler.setLevel(logging.INFO)
+        _bzr_logger.setLevel(logging.INFO)
 
 
 def is_quiet():
@@ -277,49 +376,13 @@
     return _verbosity_level > 0
 
 
+@symbol_versioning.deprecated_function(symbol_versioning.one_two)
 def disable_default_logging():
     """Turn off default log handlers.
 
-    This is intended to be used by the test framework, which doesn't
-    want leakage from the code-under-test into the main logs.
-    """
-
-    l = logging.getLogger('')
-    l.removeHandler(_stderr_handler)
-    if _file_handler:
-        l.removeHandler(_file_handler)
-    _trace_file = None
-
-
-def enable_test_log(to_file):
-    """Redirect logging to a temporary file for a test
-    
-    returns an opaque reference that should be passed to disable_test_log
-    after the test completes.
-    """
-    disable_default_logging()
-    global _trace_file
-    global _trace_depth
-    hdlr = logging.StreamHandler(to_file)
-    hdlr.setLevel(logging.DEBUG)
-    hdlr.setFormatter(logging.Formatter('%(levelname)8s  %(message)s'))
-    _bzr_logger.addHandler(hdlr)
-    _bzr_logger.setLevel(logging.DEBUG)
-    result = hdlr, _trace_file, _trace_depth
-    _trace_file = to_file
-    _trace_depth += 1
-    return result
-
-
-def disable_test_log((test_log_hdlr, old_trace_file, old_trace_depth)):
-    _bzr_logger.removeHandler(test_log_hdlr)
-    test_log_hdlr.close()
-    global _trace_file
-    global _trace_depth
-    _trace_file = old_trace_file
-    _trace_depth = old_trace_depth
-    if not _trace_depth:
-        enable_default_logging()
+    Don't call this method, use _push_log_file and _pop_log_file instead.
+    """
+    pass
 
 
 def report_exception(exc_info, err_file):
@@ -366,7 +429,6 @@
 
 def report_bug(exc_info, err_file):
     """Report an exception that probably indicates a bug in bzr"""
-    import traceback
     exc_type, exc_object, exc_tb = exc_info
     err_file.write("bzr: ERROR: %s.%s: %s\n" % (
         exc_type.__module__, exc_type.__name__, exc_object))

=== modified file 'bzrlib/version_info_formats/format_custom.py'
--- bzrlib/version_info_formats/format_custom.py	2007-12-17 17:23:21 +0000
+++ bzrlib/version_info_formats/format_custom.py	2008-01-30 15:54:33 +0000
@@ -79,6 +79,9 @@
     """Create a version file based on a custom template."""
 
     def generate(self, to_file):
+        if self._template is None:
+            raise errors.NoTemplate()
+
         info = Template()
         info.add('build_date', create_date_str())
         info.add('branch_nick', self._branch.nick)

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2007-12-29 21:28:32 +0000
+++ bzrlib/workingtree_4.py	2008-02-11 11:24:11 +0000
@@ -1951,6 +1951,11 @@
                                                  path_utf8=old_path)
                     # update the source details variable to be the real
                     # location.
+                    if old_entry == (None, None):
+                        raise errors.CorruptDirstate(state._filename,
+                            "entry '%s/%s' is considered renamed from %r"
+                            " but source does not exist\n"
+                            "entry: %s" % (entry[0][0], entry[0][1], old_path, entry))
                     source_details = old_entry[1][source_index]
                     source_minikind = source_details[0]
                 else:

